<template>
  <div class="container">
    <h1 class="display-4 font-weight-bolder">Add New Factory</h1>
    <form @submit.prevent="validateForm" class="form-container" novalidate>
      <div class="form-group">
        <label for="name">Name:</label>
        <input type="text" v-model="factory.name.name" class="form-control" required>
        <div v-if="!factory.name.name && submitted" class="invalid-feedback">Name is required.</div>
      </div>
      <div class="form-group">
        <label for="street">Street:</label>
        <input type="text" v-model="factory.name.location.street" class="form-control" required>
        <div v-if="!factory.name.location.street && submitted" class="invalid-feedback">Street is required.</div>
      </div>
      <div class="form-group">
        <label for="city">City:</label>
        <input type="text" v-model="factory.name.location.city" class="form-control" required>
        <div v-if="!factory.name.location.city && submitted" class="invalid-feedback">City is required.</div>
      </div>
      <div class="form-group">
        <label for="state">State:</label>
        <input type="text" v-model="factory.name.location.state" class="form-control" required>
        <div v-if="!factory.name.location.state && submitted" class="invalid-feedback">State is required.</div>
      </div>
      <div class="form-group">
        <label for="longitude">Longitude:</label>
        <input type="number" v-model="factory.name.location.longitude" class="form-control" required>
        <div v-if="!factory.name.location.longitude && submitted" class="invalid-feedback">Longitude is required.</div>
      </div>
      <div class="form-group">
        <label for="latitude">Latitude:</label>
        <input type="number" v-model="factory.name.location.latitude" class="form-control" required>
        <div v-if="!factory.name.location.latitude && submitted" class="invalid-feedback">Latitude is required.</div>
      </div>
      <div class="form-group">
        <label for="openingHours">Opening Hours:</label>
        <input type="text" v-model="factory.name.openingHours" class="form-control" required>
        <div v-if="!factory.name.openingHours && submitted" class="invalid-feedback">Opening Hours is required.</div>
      </div>
      <div class="form-group">
        <label for="logo">Logo:</label>
        <input type="file" @change="onFileChange" class="form-control">
      </div>
      <div class="button-group">
        <button type="submit" class="custom-btn btn-6">Save</button>
        <button type="button" class="custom-btn btn-6-red" @click="cancel">Cancel</button>
      </div>
    </form>

    <h2 class="display-6 font-weight-bolder mt-5">Available Managers</h2>
    <table class="table">
      <thead>
        <tr>
          <th scope="col">Username</th>
          <th scope="col">First Name</th>
          <th scope="col">Last Name</th>
          <th scope="col">Assign</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(manager, index) in availableManagers" :key="manager.username.username">
          <td>{{ manager.username.username }}</td>
          <td>{{ manager.username.firstName }}</td>
          <td>{{ manager.username.lastName }}</td>
          <td>
            <button v-if="!manager.assigned" @click="assignManager(index)" class="btn btn-outline-secondary btn-rounded">
              Assign
            </button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'AddFactory',
  data() {
    return {
      factory: {
        name: {
          name: '',
          location: {
            street: '',
            city: '',
            state: '',
            longitude: 0,
            latitude: 0
          },
          openingHours: '',
          logo: '',
          rating: 0,
          chocolates: [],
          manager: ''
        }
      },
      availableManagers: [], // Lista dostupnih menadžera
      submitted: false // Praćenje statusa podnošenja forme
    };
  },
  mounted() {
    this.fetchAvailableManagers();
  },
  methods: {
    fetchAvailableManagers() {
      // Provera da li API vraća podatke
      axios.get('http://localhost:3000/users/managers')
        .then(response => {
          console.log("Response data:", response.data); // Provera API odgovora
          
          // Ako je API poziv uspešan, dodaj polje 'assigned' svakom menadžeru
          this.availableManagers = response.data.map(manager => ({
            ...manager,
            assigned: false // Dodavanje polja za praćenje dodeljenog statusa
          }));
        })
        .catch(error => {
          console.error("Error fetching available managers", error);
        });
    },
    onFileChange(event) {
      const file = event.target.files[0];
      this.factory.name.logo = file ? file.name : '';
    },
    validateForm() {
      this.submitted = true;
      if (this.factory.name.name && this.factory.name.location.street && this.factory.name.location.city && this.factory.name.location.state && this.factory.name.location.longitude && this.factory.name.location.latitude && this.factory.name.openingHours) {
        this.addFactory();
      }
    },
    addFactory() {
      // Simulirani API poziv za dodavanje fabrike
      axios.post('http://localhost:3000/factories', this.factory)
        .then(response => {
          this.$router.push({ name: 'home' });
        })
        .catch(error => {
          console.error("Error adding factory", error);
        });
    },
    assignManager(index) {
      // Simulirano dodeljivanje menadžera (bez ažuriranja baze)
      this.availableManagers[index].assigned = true;
      console.log(`Assigned manager at index: ${index}`);
    },
    cancel() {
      this.$router.push({ name: 'home' });
    }
  }
};
</script>

<style scoped>
.container {
  background: #fff;
  padding: 20px;
  border-radius: 8px;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
}

.form-container {
  display: flex;
  flex-direction: column;
}

.form-group {
  margin-bottom: 15px;
}

.form-control {
  width: 100%;
  padding: 8px;
  box-sizing: border-box;
  border: 1px solid #ced4da;
  border-radius: 4px;
}

.button-group {
  display: flex;
  justify-content: space-between;
}

button {
  margin-top: 10px;
}

.table {
  margin-top: 20px;
}

.table th, .table td {
  vertical-align: middle;
}

.invalid-feedback {
  color: red;
  font-size: 0.875em;
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 0.3s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 6 - Zeleno dugme */
.btn-6 {
  background: linear-gradient(0deg, rgb(42, 156, 43) 0%, rgb(81, 246, 4) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6:before,
.btn-6:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(35, 251, 2);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6:before {
  height: 0%;
  width: 2px;
}
.btn-6:after {
  width: 0%;
  height: 2px;
}
.btn-6:hover {
  color: rgb(87, 198, 109);
  background: transparent;
}
.btn-6:hover:before {
  height: 100%;
}
.btn-6:hover:after {
  width: 100%;
}
.btn-6 span:before,
.btn-6 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(2, 251, 139);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6 span:before {
  width: 2px;
  height: 0%;
}
.btn-6 span:after {
  height: 2px;
  width: 0%;
}
.btn-6 span:hover:before {
  height: 100%;
}
.btn-6 span:hover:after {
  width: 100%;
}

/* 6 - Crveno dugme */
.btn-6-red {
  background: linear-gradient(0deg, rgb(220, 53, 69) 0%, rgb(255, 107, 114) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6-red span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6-red:before,
.btn-6-red:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red:before {
  height: 0%;
  width: 2px;
}
.btn-6-red:after {
  width: 0%;
  height: 2px;
}
.btn-6-red:hover {
  color: rgb(255, 150, 150);
  background: transparent;
}
.btn-6-red:hover:before {
  height: 100%;
}
.btn-6-red:hover:after {
  width: 100%;
}
.btn-6-red span:before,
.btn-6-red span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red span:before {
  width: 2px;
  height: 0%;
}
.btn-6-red span:after {
  height: 2px;
  width: 0%;
}
.btn-6-red span:hover:before {
  height: 100%;
}
.btn-6-red span:hover:after {
  width: 100%;
}
</style>
